<script lang="ts">
  import { flip } from "svelte/animate";
  import Card from "./Card.svelte";
  import { receive, send } from "./cardCrossfade";
  import CheckboxButton from "./CheckboxButton.svelte";
  import { GameState, Phase, PlayerState, PrivateState } from "./domain";
  import { receive as receiveHand, send as sendHand } from "./handCrossfade";
  import Score from "./Score.svelte";
  import { createActionDispatcher } from "./utils";

  const dispatchAction = createActionDispatcher();

  export let game: GameState;
  export let player: PlayerState;
  export let user: PrivateState | null;

  $: handSize = player.handSize();
  $: pickSize = player.pickSize();

  function getCardRotation(handSize: number, cardIdx: number): string {
    const angleStep = 4;
    const startAngle = (angleStep * (1 - handSize)) / 2;
    const angle = startAngle + cardIdx * angleStep;
    return `${angle}deg`;
  }

  $: handClickable =
    user &&
    [Phase.Drafting, Phase.Swapping].includes(game.phase()) &&
    game.isPlayerActive(player.id());

  function handleHandCardClick(phase: Phase, card: CardId, swap: boolean) {
    return (_: Event) => {
      switch (phase) {
        case Phase.Drafting:
          dispatchAction({ k: "Pick", cards: [card], swap });
          break;

        case Phase.Swapping:
          dispatchAction({ k: "Swap", card });
          break;
      }
    };
  }

  function isPickClickable(
    phase: Phase,
    privatePlayerState: PrivateState,
    cardIdx: number
  ) {
    switch (phase) {
      case Phase.Drafting:
        return privatePlayerState.pickedCards().length > 0;

      case Phase.Swapping:
        return cardIdx === 1;

      default:
        return false;
    }
  }
  function handlePickCardClick(phase: Phase) {
    return (_: Event) => {
      switch (phase) {
        case Phase.Drafting:
        case Phase.Swapping:
          dispatchAction({ k: "Undo" });
      }
    };
  }

  let useSwap: boolean = false;
  $: if (user?.usedSwap()) {
    useSwap = true;
  } else if (useSwap && (!user || !player.hasSwapAvailable())) {
    useSwap = false;
  }

  function isSwapping(phase: Phase, privateState: PrivateState): boolean {
    return (
      phase === Phase.Swapping &&
      privateState.usedSwap() &&
      privateState.pickedCards().length === 1
    );
  }
</script>

<div
  class="player"
  class:user={!!user}
  class:has-picked={pickSize > 0}
  class:is-swapping={user && isSwapping(game.phase(), user)}
>
  {#if user}
    {#each user.pickedCards() as card, idx (card)}
      {@const rotate = getCardRotation(pickSize, idx)}
      <button
        class="pick-card card invisibutton"
        style:--card-rotate={rotate}
        disabled={!isPickClickable(game.phase(), user, idx)}
        on:click={handlePickCardClick(game.phase())}
      >
        <div in:receive={{ key: card }} out:send={{ key: card }}>
          <Card {card} />
        </div>
      </button>
    {/each}
  {:else if game.phase() === Phase.Reveal}
    {#each player.currentPick() ?? [] as card, idx (card)}
      {@const rotate = getCardRotation(pickSize, idx)}
      <div class="pick-card" style:--card-rotate={rotate}>
        <div in:receive={{ key: card }} out:send={{ key: card }}>
          <Card {card} />
        </div>
      </div>
    {/each}
  {:else}
    {#each Array(pickSize) as _, idx}
      {@const rotate = getCardRotation(pickSize, idx)}
      <div class="pick-card" style:--card-rotate={rotate}>
        <Card faceDown />
      </div>
    {/each}
  {/if}

  {#each [player.handId()] as handId (handId)}
    <div in:receiveHand={{ key: handId }} out:sendHand={{ key: handId }}>
      <div class="hand">
        {#if user}
          {#each user.hand() as card, idx (card)}
            {@const rotate = getCardRotation(handSize, idx)}
            <button
              class="hand-card card invisibutton"
              style:--card-rotate={rotate}
              disabled={!handClickable}
              on:click={handleHandCardClick(game.phase(), card, useSwap)}
            >
              <div in:receive={{ key: card }} out:send={{ key: card }}>
                <Card {card} />
              </div>
            </button>
          {/each}
        {:else}
          {#each Array(handSize) as _, idx}
            {@const rotate = getCardRotation(handSize, idx)}
            <div class="hand-card" style:--card-rotate={rotate}>
              <Card faceDown />
            </div>
          {/each}
        {/if}
      </div>
    </div>
  {/each}

  <gs6-player-box
    playerid={player.id()}
    thinking={game.isPlayerActive(player.id())}
  >
    <div class="text-center">
      <Score score={player.score()} />
    </div>
  </gs6-player-box>

  <div class="previous-picks">
    {#each player.previousPicks() as grp, idx (idx)}
      <div class="previous-picks-group" animate:flip>
        {#each grp as card, _ (card)}
          <div in:receive={{ key: card }} out:send={{ key: card }}>
            <Card {card} />
          </div>
        {/each}
      </div>
    {/each}
  </div>

  {#if user && game.phase() === Phase.Drafting && player.hasSwapAvailable()}
    <div class="use-swap-button">
      <CheckboxButton
        disabled={user.pickedCards().length > 0}
        on:click={(_) => {
          useSwap = !useSwap;
        }}
        checked={useSwap}
      >
        <span class="nowrap"> Use Takeout Box </span>
      </CheckboxButton>
    </div>
  {/if}

  {#if user && game.phase() === Phase.Reveal && game.isPlayerActive(player.id())}
    <div class="ready-button">
      <button class="primary " on:click={() => dispatchAction({ k: "Ready" })}>
        I'm ready
      </button>
    </div>
  {/if}
</div>

<style>
  .text-center {
    text-align: center;
  }
  .nowrap {
    white-space: nowrap;
  }
  .player {
    position: relative;
    --pick-font-size: 80%;
    --hand-card-top: 5em;
    --pick-card-top: 0;
  }
  .player.user {
    --hand-font-size: 100%;
  }
  .player:not(.user) {
    --hand-font-size: 50%;
  }
  .player.has-picked {
    --hand-font-size: 50%;
    --hand-card-top: 8em;
  }
  .player.user.is-swapping {
    --hand-font-size: 100%;
    --hand-card-top: 5em;
    --pick-card-top: -2rem;
  }

  .hand {
    min-height: 1px; /* woraround for svelte crossfade, which doesn't animate if height == 0 */
  }
  .hand-card {
    --card-rotate: 0;
    --card-offset-y: 0;

    font-size: var(--hand-font-size);
    position: absolute;
    top: var(--hand-card-top);
    left: 50%;
    transform: translate(-50%, -100%) translateY(45em)
      rotate(var(--card-rotate)) translateY(-45em)
      translateY(var(--card-offset-y));
    transition: transform 0.2s;
  }

  button.card.invisibutton:not(:disabled) {
    cursor: pointer;
  }
  button.hand-card:not(:disabled):hover,
  button.hand-card:not(:disabled):focus {
    --card-offset-y: -0.5em;
  }
  button.pick-card:not(:disabled):hover,
  button.pick-card:not(:disabled):focus {
    --card-offset-y: 0.5em;
  }

  .pick-card {
    --card-rotate: 0;
    --card-offset-y: 0;
    font-size: var(--pick-font-size);
    position: absolute;

    top: var(--pick-card-top);
    left: 50%;
    transform: translate(-50%, -100%) translateY(45em)
      rotate(var(--card-rotate)) translateY(-45em)
      translateY(var(--card-offset-y));
    transition: transform 0.2s;
  }

  .previous-picks {
    display: flex;
    position: absolute;
    bottom: 0.5rem;
    left: 50%;
    transform: translate(-50%, 100%);
  }
  .previous-picks-group {
    font-size: 50%;
    margin-inline: -3.1em;

    display: flex;
    flex-direction: column;
  }
  .previous-picks-group > *:not(:first-child) {
    margin-top: -5em;
  }
  .previous-picks-group > * {
    margin-bottom: -5em;
  }
  .use-swap-button {
    position: absolute;
    bottom: 1rem;
    left: -0.5rem;
    transform: translate(-100%, 0);
  }
  .ready-button {
    position: absolute;
    bottom: 1rem;
    right: -0.5rem;
    transform: translate(100%, 0);
    white-space: nowrap;
  }
</style>
